com.smartgwt.client.tools

## Class VisualBuilder

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.layout.VLayout
            - - com.smartgwt.client.tools.VisualBuilder

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasRuleContextChangedHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers, HasMembersChangedHandlers

      public class VisualBuilder
      extends VLayout

  An application that allows developers to create and manage Smart GWT screens and datasources. This is an internal only class - do not try to use it directly in your applications. If you want to create visual tools similar to VisualBuilder, see `the Dashboards & Tools framework overview`
  See Also:
    `VisualBuilder overview and related methods`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `VisualBuilder()`
    `VisualBuilder(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `java.lang.String` | `getCustomComponentsURL()` Relative URL to Visual Builder's customComponents.xml configuration file.
    `ApplicationMode` | `getDefaultApplicationMode()` The default application mode.
    `java.lang.String` | `getDefaultComponentsURL()` Relative URL to Visual Builder's defaultComponents.xml configuration file.
    `java.lang.String` | `getDefaultMockupComponentsURL()` Relative URL to Visual Builder's defaultMockupComponents.xml configuration file.
    `java.lang.Boolean` | `getFilesystemDataSourceEnabled()` If set to true, allows the built-in save file and load file operations to access the server filesystem.
    `java.lang.String` | `getGlobalDependenciesURL()` Relative URL to Visual Builder's globalDependencies.xml configuration file.
    `PaletteNode` | `getInitialComponent()` A PaletteNode describing a component to add to an empty screen as an initial container.
    `java.lang.Boolean` | `getLoadFileBuiltinIsEnabled()` If set to true the built-in load file mechanism is enabled, allowing you to load files from offline storage or the server filesystem (if enabled)
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()` Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `java.lang.Boolean` | `getMockupMode()` If true, starts Visual Builder in mockup mode
    `boolean` | `getOpenFullBuilderSeparately()` Whether to use the existing browser window or a new one when opening a Mockup Mode screen converted to standard Component XML via "Go to Visual Builder".
    `com.google.gwt.core.client.JavaScriptObject` | `getOrCreateJsObj()`
    `static VisualBuilder` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.Boolean` | `getSaveFileBuiltinIsEnabled()` If set to true the built-in save file mechanism is enabled, allowing you to save files to offline storage or the server filesystem (if enabled)
    `java.lang.Boolean` | `getShowModeSwitcher()` If this property is not explicitly set to false, Visual Builder shows a UI to allow the `application mode` to be toggled at runtime.
    `java.lang.String` | `getSkin()` The name of a skin to use.
    `void` | `setCustomComponentsURL(java.lang.String customComponentsURL)` Relative URL to Visual Builder's customComponents.xml configuration file.
    `void` | `setDefaultApplicationMode(ApplicationMode defaultApplicationMode)` The default application mode.
    `void` | `setDefaultComponentsURL(java.lang.String defaultComponentsURL)` Relative URL to Visual Builder's defaultComponents.xml configuration file.
    `void` | `setDefaultMockupComponentsURL(java.lang.String defaultMockupComponentsURL)` Relative URL to Visual Builder's defaultMockupComponents.xml configuration file.
    `static void` | `setDefaultProperties(VisualBuilder visualBuilderProperties)` Class level method to set the default properties of this class.
    `void` | `setFilesystemDataSourceEnabled(java.lang.Boolean filesystemDataSourceEnabled)` If set to true, allows the built-in save file and load file operations to access the server filesystem.
    `void` | `setGlobalDependenciesURL(java.lang.String globalDependenciesURL)` Relative URL to Visual Builder's globalDependencies.xml configuration file.
    `void` | `setInitialComponent(PaletteNode initialComponent)` A PaletteNode describing a component to add to an empty screen as an initial container.
    `void` | `setLoadFileBuiltinIsEnabled(java.lang.Boolean loadFileBuiltinIsEnabled)` If set to true the built-in load file mechanism is enabled, allowing you to load files from offline storage or the server filesystem (if enabled)
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.tools.VisualBuilderLogicalStructure s)` Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `void` | `setMockupMode(java.lang.Boolean mockupMode)` If true, starts Visual Builder in mockup mode
    `void` | `setOpenFullBuilderSeparately(boolean openFullBuilderSeparately)` Whether to use the existing browser window or a new one when opening a Mockup Mode screen converted to standard Component XML via "Go to Visual Builder".
    `void` | `setSaveFileBuiltinIsEnabled(java.lang.Boolean saveFileBuiltinIsEnabled)` If set to true the built-in save file mechanism is enabled, allowing you to save files to offline storage or the server filesystem (if enabled)
    `void` | `setShowModeSwitcher(java.lang.Boolean showModeSwitcher)` If this property is not explicitly set to false, Visual Builder shows a UI to allow the `application mode` to be toggled at runtime.
    `void` | `setSkin(java.lang.String skin)` The name of a skin to use.

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEditProxyConstructor, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersLength, getMembersMargin, getMinMemberLength, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit_Layout, onInit, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEditProxyConstructor, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinBreadthMember, setMinBreadthMember, setMinBreadthMember, setMinMemberLength, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, encloses, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoMaskComponents, getAutoParent, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPanelContainer, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStyleName, getTabIndex, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getUseBackMask, getUseDragMask, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, removeChild, removeChild, removePeer, removePeer, removeSnapAlignCandidate, resizeBy, resizeControls, resizeFonts, resizeFonts, resizeTo, resizeTo, revealChild, revealChild, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultPageSpace, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeavePageSpace, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStyleName, setTabIndex, setTitle, setTooltip, setTop, setTop, setUseBackMask, setUseDragMask, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateEditNode, updateHover, updateHover, updateShadow, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, applyFactoryProperties, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getById, getByJSObject, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getRef, getScClassName, hasAutoAssignedID, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### VisualBuilder

          public VisualBuilder()

    - #### VisualBuilder

          public VisualBuilder(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static VisualBuilder getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `VLayout`

    - #### setCustomComponentsURL

          public void setCustomComponentsURL(java.lang.String customComponentsURL)
                                      throws java.lang.IllegalStateException

      Relative URL to Visual Builder's customComponents.xml configuration file. The default value makes the framework look wherever Visual Builder itself was loaded from
      Parameters:
        `customComponentsURL` - Default value is "customComponents.xml"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getCustomComponentsURL

          public java.lang.String getCustomComponentsURL()

      Relative URL to Visual Builder's customComponents.xml configuration file. The default value makes the framework look wherever Visual Builder itself was loaded from
      Returns:
        String

    - #### setDefaultApplicationMode

          public void setDefaultApplicationMode(ApplicationMode defaultApplicationMode)
                                         throws java.lang.IllegalStateException

      The default application mode. Note, this can be changed through the UI - see `showModeSwitcher`
      Parameters:
        `defaultApplicationMode` - Default value is "edit"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDefaultApplicationMode

          public ApplicationMode getDefaultApplicationMode()

      The default application mode. Note, this can be changed through the UI - see `showModeSwitcher`
      Returns:
        ApplicationMode

    - #### setDefaultComponentsURL

          public void setDefaultComponentsURL(java.lang.String defaultComponentsURL)
                                       throws java.lang.IllegalStateException

      Relative URL to Visual Builder's defaultComponents.xml configuration file. The default value makes the framework look wherever Visual Builder itself was loaded from
      Parameters:
        `defaultComponentsURL` - Default value is "defaultComponents.xml"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDefaultComponentsURL

          public java.lang.String getDefaultComponentsURL()

      Relative URL to Visual Builder's defaultComponents.xml configuration file. The default value makes the framework look wherever Visual Builder itself was loaded from
      Returns:
        String

    - #### setDefaultMockupComponentsURL

          public void setDefaultMockupComponentsURL(java.lang.String defaultMockupComponentsURL)
                                             throws java.lang.IllegalStateException

      Relative URL to Visual Builder's defaultMockupComponents.xml configuration file. The default value makes the framework look wherever Visual Builder itself was loaded from
      Parameters:
        `defaultMockupComponentsURL` - Default value is "defaultMockupComponents.xml"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDefaultMockupComponentsURL

          public java.lang.String getDefaultMockupComponentsURL()

      Relative URL to Visual Builder's defaultMockupComponents.xml configuration file. The default value makes the framework look wherever Visual Builder itself was loaded from
      Returns:
        String

    - #### setFilesystemDataSourceEnabled

          public void setFilesystemDataSourceEnabled(java.lang.Boolean filesystemDataSourceEnabled)
                                              throws java.lang.IllegalStateException

      If set to true, allows the built-in save file and load file operations to access the server filesystem. Note, this also requires appropriate server-side permission - your `server.properties` file must specify `FilesystemDataSource.enabled: true`.

      If this property is false, saving and loading (if enabled) will be to and from local `offline storage`.

      Parameters:
        `filesystemDataSourceEnabled` - Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setSaveFileBuiltinIsEnabled(java.lang.Boolean)`, `setLoadFileBuiltinIsEnabled(java.lang.Boolean)`

    - #### getFilesystemDataSourceEnabled

          public java.lang.Boolean getFilesystemDataSourceEnabled()

      If set to true, allows the built-in save file and load file operations to access the server filesystem. Note, this also requires appropriate server-side permission - your `server.properties` file must specify `FilesystemDataSource.enabled: true`.

      If this property is false, saving and loading (if enabled) will be to and from local `offline storage`.

      Returns:
        Boolean
      See Also:
        `getSaveFileBuiltinIsEnabled()`, `getLoadFileBuiltinIsEnabled()`

    - #### setGlobalDependenciesURL

          public void setGlobalDependenciesURL(java.lang.String globalDependenciesURL)
                                        throws java.lang.IllegalStateException

      Relative URL to Visual Builder's globalDependencies.xml configuration file. The default value makes the framework look wherever Visual Builder itself was loaded from
      Parameters:
        `globalDependenciesURL` - Default value is "globalDependencies.xml"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getGlobalDependenciesURL

          public java.lang.String getGlobalDependenciesURL()

      Relative URL to Visual Builder's globalDependencies.xml configuration file. The default value makes the framework look wherever Visual Builder itself was loaded from
      Returns:
        String

    - #### setInitialComponent

          public void setInitialComponent(PaletteNode initialComponent)
                                   throws java.lang.IllegalStateException

      A PaletteNode describing a component to add to an empty screen as an initial container.
      Parameters:
        `initialComponent` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getInitialComponent

          public PaletteNode getInitialComponent()

      A PaletteNode describing a component to add to an empty screen as an initial container.
      Returns:
        PaletteNode

    - #### setLoadFileBuiltinIsEnabled

          public void setLoadFileBuiltinIsEnabled(java.lang.Boolean loadFileBuiltinIsEnabled)
                                           throws java.lang.IllegalStateException

      If set to true the built-in load file mechanism is enabled, allowing you to load files from offline storage or the server filesystem (if enabled)
      Parameters:
        `loadFileBuiltinIsEnabled` - Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setFilesystemDataSourceEnabled(java.lang.Boolean)`

    - #### getLoadFileBuiltinIsEnabled

          public java.lang.Boolean getLoadFileBuiltinIsEnabled()

      If set to true the built-in load file mechanism is enabled, allowing you to load files from offline storage or the server filesystem (if enabled)
      Returns:
        Boolean
      See Also:
        `getFilesystemDataSourceEnabled()`

    - #### setMockupMode

          public void setMockupMode(java.lang.Boolean mockupMode)
                             throws java.lang.IllegalStateException

      If true, starts Visual Builder in mockup mode
      Parameters:
        `mockupMode` - Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMockupMode

          public java.lang.Boolean getMockupMode()

      If true, starts Visual Builder in mockup mode
      Returns:
        Boolean

    - #### setOpenFullBuilderSeparately

          public void setOpenFullBuilderSeparately(boolean openFullBuilderSeparately)
                                            throws java.lang.IllegalStateException

      Whether to use the existing browser window or a new one when opening a Mockup Mode screen converted to standard Component XML via "Go to Visual Builder".
      Parameters:
        `openFullBuilderSeparately` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getOpenFullBuilderSeparately

          public boolean getOpenFullBuilderSeparately()

      Whether to use the existing browser window or a new one when opening a Mockup Mode screen converted to standard Component XML via "Go to Visual Builder".
      Returns:
        boolean

    - #### setSaveFileBuiltinIsEnabled

          public void setSaveFileBuiltinIsEnabled(java.lang.Boolean saveFileBuiltinIsEnabled)
                                           throws java.lang.IllegalStateException

      If set to true the built-in save file mechanism is enabled, allowing you to save files to offline storage or the server filesystem (if enabled)
      Parameters:
        `saveFileBuiltinIsEnabled` - Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setFilesystemDataSourceEnabled(java.lang.Boolean)`

    - #### getSaveFileBuiltinIsEnabled

          public java.lang.Boolean getSaveFileBuiltinIsEnabled()

      If set to true the built-in save file mechanism is enabled, allowing you to save files to offline storage or the server filesystem (if enabled)
      Returns:
        Boolean
      See Also:
        `getFilesystemDataSourceEnabled()`

    - #### setShowModeSwitcher

          public void setShowModeSwitcher(java.lang.Boolean showModeSwitcher)
                                   throws java.lang.IllegalStateException

      If this property is not explicitly set to false, Visual Builder shows a UI to allow the `application mode` to be toggled at runtime.
      Parameters:
        `showModeSwitcher` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowModeSwitcher

          public java.lang.Boolean getShowModeSwitcher()

      If this property is not explicitly set to false, Visual Builder shows a UI to allow the `application mode` to be toggled at runtime.
      Returns:
        Boolean

    - #### setSkin

          public void setSkin(java.lang.String skin)
                       throws java.lang.IllegalStateException

      The name of a skin to use. Note that Visual Builder may use two skins - the skin specified here, for the elements of the application you are building, and a high-contrast, white-on-black "ToolSkin" for the elements of Visual Builder itself. When in "Toolskin" mode (which is switchable at runtime through the UI), the `skin` property only affects the skin used by the visual elements of the application you are building.
      Parameters:
        `skin` - Default value is "Graphite"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getSkin

          public java.lang.String getSkin()

      The name of a skin to use. Note that Visual Builder may use two skins - the skin specified here, for the elements of the application you are building, and a high-contrast, white-on-black "ToolSkin" for the elements of Visual Builder itself. When in "Toolskin" mode (which is switchable at runtime through the UI), the `skin` property only affects the skin used by the visual elements of the application you are building.
      Returns:
        String

    - #### setDefaultProperties

          public static void setDefaultProperties(VisualBuilder visualBuilderProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `visualBuilderProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### getOrCreateJsObj

          public com.google.gwt.core.client.JavaScriptObject getOrCreateJsObj()

      Overrides:
        `getOrCreateJsObj` in class `BaseWidget`

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.tools.VisualBuilderLogicalStructure s)

      Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `VLayout`